from Products.CMFCore.utils import getToolByName
from Products.CMFFormController.FormAction import FormActionKey
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin
from Products.Archetypes.public import listTypes

from StringIO import StringIO

from Products.CMFDynamicViewFTI.migrate import migrateFTIs

from Products.CopyrightedFile.config import *

def install(self):
    out = StringIO()
    
    installTypes(self, out,
                 listTypes(PROJECTNAME),
                 PROJECTNAME)

    install_subskin(self, out, GLOBALS)
    
    # Migrate FTI, to make sure we get the necessary infrastructure for the
    # 'display' menu to work.
    migrated = migrateFTIs(self, product=PROJECTNAME)
    print >>out, "Switched to DynamicViewFTI: %s" % ', '.join(migrated)

    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    if 'CopyrightedFile' not in types:
        types.append('CopyrightedFile')
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)

    print >> out, "Added CopyrightedFile to portal_factory"

    # Add to default_page_types
    propsTool = getToolByName(self, 'portal_properties')
    siteProperties = getattr(propsTool, 'site_properties')
    defaultPageTypes = list(siteProperties.getProperty('default_page_types'))
    if 'CopyrightedFile' not in defaultPageTypes:
        defaultPageTypes.append('CopyrightedFile')
    siteProperties.manage_changeProperties(default_page_types = defaultPageTypes)

    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()