import Globals
from AccessControl import ClassSecurityInfo

from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions

from Products.ATContentTypes.content.folder import ATFolder
from Products.ATContentTypes.content.schemata import finalizeATCTSchema
from Products.CopyrightedFile.interfaces import ICopyrightedFile
from Products.CopyrightedFile.Permissions import *

schema = ATFolder.schema

class SubCopyrightedFile(ATFolder):
    """A sub page within a copyrighted file"""
    schema = schema
    actions = ATFolder.actions
#    immediate_view = "base_edit"
    global_allow = 0
    filter_content_types = 1
    allowed_content_types = (['Copyright', 'FileWithCopyright'])
    archetype_name = portal_type = "SubCopyrightedFile"
    meta_type = "SubCopyrightedFile"
    content_icon = "icon_CopyrightedFile_small.gif"
    include_default_actions = 1
    _at_rename_after_creation = True
    
    # Set up our views - these are available from the 'display' menu
   
    default_view = 'CopyrightedFile_view_base'
    immediate_view = 'CopyrightedFile_view_base'
    suppl_views = ('CopyrightedFile_view_base','CopyrightedFile_view_Copyright','CopyrightedFile_view_FileWithCopyright')

    __implements__ = OrderedBaseFolder.__implements__ + \
                     ATFolder.__implements__

    security = ClassSecurityInfo()
    
    # Set security for the object itslef

    security.declareProtected(VIEW_CONTENTS_PERMISSION, 'isMultipage')
    def isMultipage(self):
        """Return true if there is more than one page in the copyrighted file"""
        return True

    security.declareProtected(VIEW_CONTENTS_PERMISSION, 'getCopyrights')
    def getCopyrights(self):
        """Return the copyrights for this copyrighted file"""
        contents = self.getFolderContents(contentFilter={'portal_type':'Copyright',})
        return contents
        
    security.declareProtected(VIEW_CONTENTS_PERMISSION, 'getCopyrightedFiles')
    def getCopyrightedFiles(self):
        """Return the copyrighted file"""
        contents = self.getFolderContents(contentFilter={'portal_type':'FileWithCopyright',})
        return contents

    security.declareProtected(VIEW_CONTENTS_PERMISSION, 'getAllContents')
    def getAllContents(self):
        """Return all the contents in the copyrighted file"""
        portal_catalog = getToolByName(self, 'portal_catalog')
        contents = []
        path = string.join(self.getPhysicalPath(), '/')
        results = portal_catalog.searchResults('portal_type' in ('Copyright', 'FileWithCopyright'),
                                               path = path)
        for result in results:
            questions.append(result.getObject())
        return contents

    security.declareProtected(VIEW_CONTENTS_PERMISSION, 'getNextPage')
    def getNextPage(self):
        """Return the next page of the copyrighted file"""
        pages = self.getFolderContents(contentFilter={'portal_type':'SubCopyrightedFile',})
        if pages:
            return pages[0]()
        # no next page, so copyrighted file finished
        self.setCompletedForUser()
        return self.exitCopyrightedFile()

    security.declareProtected(VIEW_CONTENTS_PERMISSION, 'checkCompleted')
    def checkCompleted(self):
        """Return true if this page is completed"""
        # XXX
        return True



Globals.InitializeClass(SubCopyrightedFile)
registerType(SubCopyrightedFile)
